/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
extern FILE *fp1,*fp2;                                      /* File pointers. */
/******************************************************************************/
/*                     VARIABLES RELATED TO THE FRAME.
*******************************************************************************/
extern int Ber;                                            /* Bit-error-rate. */
extern int Tx_Samp_Cnt;                                /* Sample count at tx. */
extern int Rx_Samp_Cnt;                                /* Sample count at rx. */
extern int Frame_Cnt;                                         /* Frame count. */
extern int Sym[FRAME_SIZE];                                /* Stores symbols. */
extern double Map[BPSK_SIZE];                         /* Stores BPSK mapping. */
/******************************************************************************/
/*                        TRANSMIT FILTER VARIABLES.
*******************************************************************************/
extern double Rand_Tx_Delay;                                 /* Random delay. */
extern double Re_Tx_Op;                                       /* Re. tx. o/p. */
extern double Im_Tx_Op;                                       /* Im. tx. o/p. */
extern double Tx_Flt[TX_FLT_SIZE];                        /* Transmit filter. */
extern double Re_Tx_Reg[TX_FLT_SIZE];                         /* Re. tx. reg. */
extern double Im_Tx_Reg[TX_FLT_SIZE];                         /* Im. tx. reg. */
/******************************************************************************/
/*                  VARIABLES RELATED TO THE MODULATED SIGNAL.
*******************************************************************************/
extern double Passband_Signal;                            /* Passband signal. */
extern double Initial_Phase;                  /* Initial carrier phase at tx. */
extern double Theta;                             /* Starting phase at the tx. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double Variance;                                    /* Noise variance. */
extern double Inv_Twice_Noise_Var;    /* Inverse of twice the noise variance. */
extern double N1_Val[NVALSIZE];                  /* Contains U & G rand. var. */
/******************************************************************************/
/*               LOCAL OSCILLATOR (AT THE RECEIVER) VARIABLES.
*******************************************************************************/
extern double Re_LO[LO_PERIOD];                         /* Cosine term of LO. */
extern double Im_LO[LO_PERIOD];                           /* Sine term of LO. */
extern double Re_LO_Op;                                        /* Re. LO o/p. */
extern double Im_LO_Op;                                        /* Im. LO o/p. */
/******************************************************************************/
/*                         MATCHED FILTER VARIABLES.
*******************************************************************************/
extern double Rx_Re_Sym;                                   /* Rx. re. symbol. */
extern double Rx_Im_Sym;                                   /* Rx. im. symbol. */
extern double MF[MF_SIZE];                                 /* Matched filter. */
extern double Re_MF_Reg[MF_SIZE];                              /* Re. MF reg. */
extern double Im_MF_Reg[MF_SIZE];                              /* Im. MF reg. */
extern double Re_MF_Op[RX_SAMP_SIZE];                          /* Re. MF o/p. */
extern double Im_MF_Op[RX_SAMP_SIZE];                          /* Im. MF o/p. */
/******************************************************************************/
/*                   TIMING AND CARRIER RECOVERY VARIABLES.
*******************************************************************************/
extern int Samp_Instant;                                 /* Sampling instant. */
extern int Mean_Corr_Cnt;                /* Ctr. for the no. of correlations. */
extern double Re_Tim_Corr;                         /* Re. timing correlation. */
extern double Im_Tim_Corr;                         /* Im. timing correlation. */
extern double Re_Mean_Corr;                   /* Re. mean of the correlation. */
extern double Im_Mean_Corr;                   /* Im. mean of the correlation. */
extern double Re_Tim_Max;                            /* Re. correlation peak. */
extern double Im_Tim_Max;                            /* Im. correlation peak. */
extern double Tim_Max_Mag;                  /* Max. magnitude of correlation. */
extern double Est_Phase;                          /* Estimated carrier phase. */
extern double Phase_Var;                                /* Var. of phase est. */
extern double Tim_Var;                                   /* Var. of tim. est. */
extern double Re_Amp;                                       /* Re. amplitude. */
extern double Im_Amp;                                       /* Im. amplitude. */
extern double Est_Var;                                 /* Estimated variance. */
/******************************************************************************/
