#*******************************************************************************
#    Copyright (C) 2008 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the bit error rates for  turbo coded QPSK.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "uc_qpsk.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "uc_qpsk.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key left bottom box
#set key below box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
set output "ber_pmb500.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "Bit error rate"
plot "ber_pmb500_c98_t995.dat" t "rho_c=0.98, rho_t=0.995"\
      w linespoints lt -1 lw 1 pt 1 ps 2,\
     "ber_pmb500_c97_t995.dat" t "rho_c=0.97, rho_t=0.995"\
      w linespoints lt -1 lw 1 pt 2 ps 2,\
     "ber_pmb500_c99_t995.dat" t "rho_c=0.99, rho_t=0.995"\
      w linespoints lt -1 lw 1 pt 3 ps 2,\
     "ber_pmb500_c98_t994.dat" t "rho_c=0.98, rho_t=0.994"\
      w linespoints lt -1 lw 1 pt 4 ps 2,\
     "ber_pmb500_c98_t993.dat" t "rho_c=0.98, rho_t=0.993"\
      w linespoints lt -1 lw 1 pt 5 ps 2,\
     "ber_pmb500_c98_t992.dat" t "rho_c=0.98, rho_t=0.992"\
      w linespoints lt  1 lw 2 pt 6 ps 2,\
     "ber_pmb500_c98_t991.dat" t "rho_c=0.98, rho_t=0.991"\
      w linespoints lt  1 lw 2 pt 7 ps 2,\
     "ber_pmb500_c98_t996.dat" t "rho_c=0.98, rho_t=0.996"\
      w linespoints lt  1 lw 2 pt 8 ps 2,\
     "bare_tc.dat" t "bare turbo code"\
      w linespoints lt  1 lw 2 pt 9 ps 2
