/******************************************************************************/
/*   Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal10type.h"
#include "deal10ext.h"
/******************************************************************************/
/*                             Sample the MF output.
*******************************************************************************/
int Sample_MF_Op(tim_win_inx)
int tim_win_inx;
{
 int inx,cnt,cnt1,cnt2;
 inx=tim_win_inx+TIM_WINDOW;
 cnt=Sym_Cnt/TWO-PRE_AMB_SS;
 cnt1=Sym_Cnt%TWO;
 cnt2=Sym_Cnt/TWO;
 if((cnt < ZERO) && (cnt1 == ZERO))
  Est_Pre_Amb_Phase(inx);
 else if((cnt == ZERO) && (cnt1 == ZERO))
  Init_ISI_Reg_for_Ph_Est();
 if(cnt >= ZERO)
  Start_Data_Proc(tim_win_inx);
 return(0);
}
/******************************************************************************/
/*                      Estimate the preamble phase.
*******************************************************************************/
int Est_Pre_Amb_Phase(inx)
int inx;
{
 int cnt;
 double re_op,im_op,re_val,im_val,mag,re_tmp,im_tmp,tim_amp;
 cnt=Sym_Cnt/TWO;
 re_val=Map[Sym[cnt]&ONE];
 im_val=Im_ISI[cnt];
 re_op=Re_MF_Op[inx];
 im_op=Im_MF_Op[inx];
 Tim_Derotate(re_op,im_op,&tim_amp);
 tim_amp=tim_amp*re_val;
 mag=re_val*re_val+im_val*im_val;
 re_tmp=(Re_MF_Op[inx]*re_val+Im_MF_Op[inx]*im_val)/mag;
 im_tmp=(Im_MF_Op[inx]*re_val-Re_MF_Op[inx]*im_val)/mag;
 Get_IIR_Avg_Amp(tim_amp,re_tmp,im_tmp,inx);
 return(0);
}
/******************************************************************************/
/*                Perform derotation for tracking the timing.
*******************************************************************************/
int Tim_Derotate(re_op,im_op,tim_amp)
double re_op,im_op,*tim_amp;
{
 Cost=cos(Est_Phase);
 Sint=sin(Est_Phase);
 *tim_amp=re_op*Cost+im_op*Sint;
 return(0);
}
/******************************************************************************/
/* Initialize the ISI reg. for phase estimation. The most recent symbol is
 * at zero.
*******************************************************************************/
int Init_ISI_Reg_for_Ph_Est()
{
 int cnt;
 for(cnt=ZERO;cnt<ISI_LEN;cnt++)
  ISI_Reg[cnt]=Map[Sym[PRE_AMB_SIZE-ONE-cnt]>>ONE];
 return(0);
}
/******************************************************************************/
/*    Start processing the last portion of the preamble and the data part.
*******************************************************************************/
int Start_Data_Proc(tim_win_inx)
int tim_win_inx;
{
 int cnt,cnt1,cnt2;
 cnt=Sym_Cnt/TWO-PRE_AMB_SS;
 cnt1=Sym_Cnt%TWO;
 cnt2=Sym_Cnt/TWO;
 if(tim_win_inx == ZERO)
  Data_Process();
 if((cnt1 == ONE) && (tim_win_inx == TIM_WINDOW) && (cnt >= SYM_BUF_LEN))
 {
  Update_Data_Phase();
  if((Tim_Track == FALSE) && (cnt2 == Nxt_Tim_Track_Instant))
   Tim_Track=TRUE;
  if((Tim_Track == TRUE) && (IDEAL_TIM == ZERO))
   Get_New_Tim_Peak();
 }
 return(0);
}
/******************************************************************************/
/*                  Process the phase of the data symbols.
*******************************************************************************/
int Data_Process()
{
 int cnt,cnt1;
 Derotate();
 cnt=Sym_Cnt/TWO-PRE_AMB_SS;
 cnt1=Sym_Cnt%TWO;
 if(cnt1 == ZERO)
  Shift_Into_Re_Sym_Reg();
 if((cnt >= SYM_BUF_LEN) && (cnt < (SYM_BUF_LEN+DATA_SIZE)) && (cnt1 == ONE))
 {
  Get_Errors(cnt);
  Get_Noisy_Sym(cnt);
  Shift_Into_ISI_Reg();
 }
 return(0);
}
/******************************************************************************/
/*                  Derotate samples to get current symbol.
*******************************************************************************/
int Derotate()
{
 int cnt1,cnt2;
 double re_tmp1,im_tmp1;
 re_tmp1=Re_MF_Op[TIM_WINDOW];
 im_tmp1=Im_MF_Op[TIM_WINDOW];
 cnt1=Sym_Cnt%TWO;
 cnt2=Sym_Cnt/TWO;
 if(((cnt2%CPLL_UPDATE_RATE) == ZERO) && (cnt1 == ZERO))
  Get_Present_Carrier_Phase();
 Cost=cos(Est_Phase);
 Sint=sin(Est_Phase);
 if((Sym_Cnt%TWO) == ZERO)
 {
  Rx_Re_Sym1=re_tmp1*Cost+im_tmp1*Sint;
  Rx_Im_Sym1=im_tmp1*Cost-re_tmp1*Sint;
 }
 else
 {
  Rx_Re_Sym2=re_tmp1*Cost+im_tmp1*Sint;
  Rx_Im_Sym2=im_tmp1*Cost-re_tmp1*Sint;
 }
 return(0);
}
/******************************************************************************/
/*                     Get the present carrier phase.
*******************************************************************************/
int Get_Present_Carrier_Phase()
{
 double re_amp,im_amp;
 re_amp=C_Avg_Re_Amp;
 im_amp=C_Avg_Im_Amp;
 Est_Phase=atan(im_amp/re_amp);
 if(re_amp < FRAC_ZERO)
  Est_Phase=Est_Phase+M_PI;
 else if((re_amp > FRAC_ZERO) && (im_amp < FRAC_ZERO))
  Est_Phase=Est_Phase+2.0*M_PI;
 if(IDEAL_CAR == 1)
  Est_Phase=FRAC_ZERO;
 return(0);
}
/******************************************************************************/
/*     Store the real part of the symbol. Most recent symbol is at zero.
*******************************************************************************/
int Shift_Into_Re_Sym_Reg()
{
 Re_Shift_from_Zero(Re_Sym_Buf,SYM_BUF_LEN_P1);
 if(Rx_Re_Sym1 > FRAC_ZERO)
  Re_Sym_Buf[ZERO]=  1.0;
 else
  Re_Sym_Buf[ZERO]= -1.0;
 return(0);
}
/******************************************************************************/
/*                              Get the errors.
*******************************************************************************/
int Get_Errors(cnt)
int cnt;
{
 int bit0,bit1,rx_bit0,rx_bit1,cnt1;
 rx_bit0=rx_bit1=ZERO;
 bit0=Sym[cnt+PRE_AMB_SIZE-SYM_BUF_LEN]&ONE;
 bit1=Sym[cnt+PRE_AMB_SIZE-SYM_BUF_LEN]>>ONE;
 if(Rx_Re_Sym1 < FRAC_ZERO)
  rx_bit0=ONE;
 if(Rx_Im_Sym2 < FRAC_ZERO)
  rx_bit1=ONE;
 if(bit0 != rx_bit0)
  Ber++;
 if(bit1 != rx_bit1)
  Ber++;
 return(0);
}
/******************************************************************************/
/*                          Get the noisy symbols.
*******************************************************************************/
int Get_Noisy_Sym(cnt)
int cnt;
{
 int inx;
 Sym0[cnt-SYM_BUF_LEN]=Rx_Re_Sym1;
 if(((cnt-SYM_BUF_LEN)%TWO) == ZERO)
  Sym1[cnt-SYM_BUF_LEN]=Rx_Im_Sym2;
 else
  Sym2[cnt-SYM_BUF_LEN]=Rx_Im_Sym2;
// printf("time:%d Sym0:%lf\n",cnt-SYM_BUF_LEN,Sym0[cnt-SYM_BUF_LEN]);
 return(0);
}
/******************************************************************************/
/*  Shift new imaginary symbol into the ISI registers. The most recent
 *  imaginary symbol is at zero.
*******************************************************************************/
int Shift_Into_ISI_Reg()
{
 int cnt,inx;
 double re_tmp1,im_tmp1,re_sym3,im_sym3;
 Re_Shift_from_Zero(ISI_Reg,ISI_LEN);
 if(Rx_Im_Sym2 > FRAC_ZERO)
  ISI_Reg[ZERO]=  1.0;
 else
  ISI_Reg[ZERO]= -1.0;
 return(0);
}
/******************************************************************************/
/*               Update the carrier phase of the data symbols.
*******************************************************************************/
int Update_Data_Phase()
{
 int cnt,cnt1,inx;
 double re_val,im_val,mag,re_tmp,im_tmp,re_op,im_op,tim_amp;
 cnt1=SYM_BUF_LEN_P1-ONE;
 im_val=0.0;
 for(cnt=ZERO;cnt<ISI_LEN;cnt++)
  im_val=im_val+ISI_Coeff[cnt]*ISI_Reg[cnt];
 re_val=Re_Sym_Buf[cnt1];
 mag=re_val*re_val+im_val*im_val;
 for(inx=ZERO;inx<TIM_WIN_LEN;inx++)
 {
  re_op=Re_MF_Op_Buf[inx][cnt1];
  im_op=Im_MF_Op_Buf[inx][cnt1];
  Tim_Derotate(re_op,im_op,&tim_amp);
  tim_amp=tim_amp*re_val;
  re_tmp=(re_op*re_val+im_op*im_val)/mag;
  im_tmp=(im_op*re_val-re_op*im_val)/mag;
  Get_IIR_Avg_Amp(tim_amp,re_tmp,im_tmp,inx);
 }
 return(0);
}
/******************************************************************************/
/*                         Get the new timing instant.
*******************************************************************************/
int Get_New_Tim_Peak()
{
 int max_inx,offset,sum;
 max_inx=Get_New_Tim_Peak_1();
 offset=max_inx-TIM_WINDOW;
 Int_Shift_from_Zero(Tim_Reg,TIM_REG_SIZE);
 Tim_Reg[ZERO]=offset;
 sum=Get_Sum_Tim_Reg();
 Process_Tim_Reg_Sum(sum);
 return(0);
}
/******************************************************************************/
/*                         Get the new timing instant.
*******************************************************************************/
int Get_New_Tim_Peak_1()
{
 int cnt,max_inx;
 double max,mag;
 max=MIN_MAG;
 for(cnt=ZERO;cnt<TIM_WIN_LEN;cnt++)
 {
  mag=Avg_Re_Amp[cnt];
//  printf("sym:%d inx:%d re_amp:%lf\n",Sym_Cnt/TWO,cnt,mag);
  if(mag > max)
  {
   max=mag;
   max_inx=cnt;
  }
 }
 return(max_inx);
}
/******************************************************************************/
/*            Get the sum of the elements in the timing register.
*******************************************************************************/
int Get_Sum_Tim_Reg()
{
 int sum,cnt;
 sum=ZERO;
 for(cnt=ZERO;cnt<TIM_REG_SIZE;cnt++)
  sum=sum+Tim_Reg[cnt];
 return(sum);
}
/******************************************************************************/
/*          Process the sum of the elements in the timing register.
*******************************************************************************/
int Process_Tim_Reg_Sum(sum)
int sum;
{
 if(sum == -TIM_OBS_LEN)
 {
  Re_Shift_from_Zero(Avg_Re_Amp,TIM_WIN_LEN);        /* Comment for ideal rx. */
  Tim_Offset=MINUSONE;
  Avg_Re_Amp[ZERO]=FRAC_ZERO;
 }
 else if(sum == TIM_OBS_LEN)
 {
  Re_Shift_to_Zero(Avg_Re_Amp,TIM_WIN_LEN);          /* Comment for ideal rx. */
  Tim_Offset=ONE;
  Avg_Re_Amp[TIM_WIN_LEN-ONE]=FRAC_ZERO;
 }
 else
  Tim_Offset=ZERO;
 if(Tim_Offset != ZERO)
  Update_Timing();
 return(0);
}
/******************************************************************************/
/*                              Update the timing.
*******************************************************************************/
int Update_Timing()
{
 int cnt;
 if(Frame_Cnt == PRINT_FRAME)
  printf("\t Sym:%d mod:%d offset:%d\n",Sym_Cnt/TWO,Sym_Cnt%TWO,Tim_Offset);
 Cum_Tim_Offset=Cum_Tim_Offset+Tim_Offset;              /* Cumulative offset. */
// Tim_Offset=ZERO;                          /* Comment for normal operation. */
 Tim_Track=FALSE;                                           /* Stop tracking. */
 Nxt_Tim_Track_Instant=Sym_Cnt/TWO+TPLL_UPDATE_RATE;  /* Start tracking here. */
 for(cnt=ZERO;cnt<TIM_REG_SIZE;cnt++)         /* Reinitialize the timing reg. */
  Tim_Reg[cnt]=ZERO;
 return(0);
}
/******************************************************************************/
/*                         Turbo decoder routines.
*******************************************************************************/
int Turbo_Dec()
{
 Init_Gamma_I_E();
 Init_App();
 Bcjr();
 Get_Bit_Errors_Dec1();
 return(0);
}
/******************************************************************************/
/*          Initialize the intrinsic and extrinsic values of gamma.
*******************************************************************************/
int Init_Gamma_I_E()
{
 Init_Gamma_I_E_Dec1();
 Init_Gamma_I_E_Dec2();
 return(0);
}
/******************************************************************************/
/*    Initialize the intrinsic and extrinsic values of gamma for decoder 1.
*******************************************************************************/
int Init_Gamma_I_E_Dec1()
{
 int time,bit;
 for(time=ZERO;time<DATA_SIZE;time++)
 {
  for(bit=ZERO;bit<NUM_INPUTS;bit++)
  {
   Compute_Gamma_E_P1(bit,time);
   Compute_Gamma_I(bit,time);
  }
 }
 return(0);
}
/******************************************************************************/
/*     Compute gamma from parity bit (extrinsic information) for decoder 1.
*******************************************************************************/
int Compute_Gamma_E_P1(bit,time)
int bit,time;
{
 double sym,x;
 if((time%TWO) == ZERO)
 {
  sym=Map[bit]*Avg_Amp1;
  x=sym-Sym1[time];
  x= -x*x*Inv_Twice_Noise_Var;
  Gamma_E_P1[time][bit]=exp(x);
 }
 else
  Gamma_E_P1[time][bit]=1.0;
 return(0);
}
/******************************************************************************/
/*      Compute gamma from data bit (intrinsic information) for decoder 1.
*******************************************************************************/
int Compute_Gamma_I(bit,time)
int bit,time;
{
 double sym,x;
 sym=Map[bit]*Avg_Amp1;
 x=sym-Sym0[time];
 x= -x*x*Inv_Twice_Noise_Var;
 Gamma_I[time][bit]=exp(x);
 return(0);
}
/******************************************************************************/
/*    Initialize the intrinsic and extrinsic values of gamma for decoder 2.
*******************************************************************************/
int Init_Gamma_I_E_Dec2()
{
 int time,bit;
 for(time=ZERO;time<DATA_SIZE;time++)
 {
  for(bit=ZERO;bit<NUM_INPUTS;bit++)
   Compute_Gamma_E_P2(bit,time);
 }
 return(0);
}
/******************************************************************************/
/*     Compute gamma from parity bit (extrinsic information) for decoder 2.
*******************************************************************************/
int Compute_Gamma_E_P2(bit,time)
int bit,time;
{
 double sym,x;
 if((time%TWO) != ZERO)
 {
  sym=Map[bit]*Avg_Amp1;
  x=sym-Sym2[time];
  x= -x*x*Inv_Twice_Noise_Var;
  Gamma_E_P2[time][bit]=exp(x);
 }
 else
  Gamma_E_P2[time][bit]=1.0;
 return(0);
}
/******************************************************************************/
/*                Initialize the a posteriori probabilities.
*******************************************************************************/
int Init_App()
{
 int time,input;
 for(time=ZERO;time<DATA_SIZE;time++)
 {
  for(input=ZERO;input<NUM_INPUTS;input++)
   Prob[time][input]=0.5;
 }
 return(0);
}
/******************************************************************************/
/*                          The BCJR algorithm.
*******************************************************************************/
int Bcjr()
{
 for(Iter=ZERO;Iter<MAX_ITER;Iter++)
 {
  Dec2_Process();
  Dec1_Process();
 }
 return(0);
}
/******************************************************************************/
/*    Finally compute the number of bit errors in the frame from decoder1.
*******************************************************************************/
int Get_Bit_Errors_Dec1()
{
 int time,detected_bit,act_bit;
 for(time=ZERO;time<DATA_SIZE;time++)
 {
  detected_bit=ONE;
  if(Prob[time][ZERO] > Prob[time][ONE])
   detected_bit=ZERO;
  act_bit=Bits[time];
  if(detected_bit != Bits[time])
   T_Ber++;
  Valid_Bit++;
 }
 return(0);
}
/******************************************************************************/
/*                       Print out the probabilities.
*******************************************************************************/
int Print_Prob()
{
 int time,act_bit;
 for(time=ZERO;time<DATA_SIZE;time++)
 {
  act_bit=Bits[time];
  printf("Print prob Frame:%d time:%d tx bit:%d ",Frame_Cnt,time,act_bit);
  printf("Prob 0:%lf  ",Prob[time][0]);
  printf("Prob 1:%lf\n",Prob[time][1]);
 }
 return(0);
}
/******************************************************************************/
