/******************************************************************************/
/*   Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal7type.h"
#include "deal7ext.h"
/******************************************************************************/
int Ck_Var()
{
 Ck_Data_Size();
 Ck_Post_Amble();
 Ck_Tx_Ip_Fac();
 Ck_Rx_Samp_Per_Sym();
 Ck_ISI_Len();
 Ck_Tim();
 Ck_Car();
 Ck_ML_Length1();
 return(0);
}
/******************************************************************************/
/*                         Check the datasize.
*******************************************************************************/
int Ck_Data_Size()
{
 if((DATA_SIZE%TWO) != ZERO)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*                       Check the size of the post amble.
*******************************************************************************/
int Ck_Post_Amble()
{
 int size;
 size=4*(int)(TX_DELAY/TX_IP_FAC);
 if(size != POST_AMBLE)
  Error_Mes(6);
 return(0);
}
/******************************************************************************/
/*            Check the interpolation factor at the transmitter.
*******************************************************************************/
int Ck_Tx_Ip_Fac()
{
 if((TX_IP_FAC%TWO) == ONE)
  Error_Mes(7);
 return(0);
}
/******************************************************************************/
/*                 Check the no. of samples per symbol at rx.
*******************************************************************************/
int Ck_Rx_Samp_Per_Sym()
{
 if((RX_SAMP_PER_SYM%TWO) == ONE)
  Error_Mes(11);
 return(0);
}
/******************************************************************************/
/*                            Check the ISI length.
*******************************************************************************/
int Ck_ISI_Len()
{
 if((ISI_LEN%TWO) == ONE)
  Error_Mes(10);
 return(0);
}
/******************************************************************************/
/*       Check for consistency in ideal and random timing declarations.
*******************************************************************************/
int Ck_Tim()
{
 if((RAND_TIM == 1) && (IDEAL_TIM == 1))
  Error_Mes(12);
 return(0);
}
/******************************************************************************/
/*    Check for consistency in ideal and random carrier phase declarations.
*******************************************************************************/
int Ck_Car()
{
 if((RAND_PHASE == 1) && (IDEAL_CAR == 1))
  Error_Mes(13);
 if(abs(F_OFF) > ERROR)
  Error_Mes(14);
 return(0);
}
/******************************************************************************/
/*   Check the length of the preamble for the 1st iteration of the ML freq.
     offset estimation.
*******************************************************************************/
int Ck_ML_Length1()
{
 if(ML_LENGTH1 > PRE_AMB_SS)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
