#*******************************************************************************
#    Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the RMS frequency offset error for uncoded QPSK.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "uc_qpsk.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "uc_qpsk.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
set term postscript eps color 22
set key box
set grid xtics ytics mytics lw 0.5, lw 0.5
set format y "%2.1e"
set output "ferr.eps"
set logscale y
#set xlabel "E_b/N_0 (dB)"
#set ylabel "RMS estimation error (radians)"
plot "ferr_txd_18_foff_1_att_1.dat" t\
     "Diff. 1st attempt"\
      w linespoints lt -1 lw 1 pt 1,\
     "ferr_txd_18_foff_1_att_2.dat" t "Diff. 2nd attempt"\
      w linespoints lt -1 lw 1 pt 2,\
     "ferr_txd_18_foff_1_ml.dat" t "ML, w_s=1*10^{-4}"\
      w linespoints lt -1 lw 1 pt 3,\
     "ferr_txd_18_foff_5_ml.dat" t "ML, w_s=5*10^{-4}"\
      w linespoints lt -1 lw 1 pt 4
