/******************************************************************************/
/*   Copyright (C) 2005 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal7type.h"
#include "deal7ext.h"
/******************************************************************************/
int Post_Processor()
{
 Get_Parameters();
 Print_Parameters();
 return(0);
}
/******************************************************************************/
/*                        Compute various parameters.
*******************************************************************************/
int Get_Parameters()
{
 int valid_fr;
 valid_fr=MAX_FRAMES-Erasure;
 Tim_Var=Tim_Var/(double)(valid_fr*RX_SAMP_PER_SYM*RX_SAMP_PER_SYM);
 Tim_Var_2=Tim_Var_2/(double)(valid_fr*RX_SAMP_PER_SYM*RX_SAMP_PER_SYM);
 Tim_Var_3=Tim_Var_3/(double)(valid_fr*RX_SAMP_PER_SYM*RX_SAMP_PER_SYM);
 F_Off_RMS=sqrt(F_Off_RMS/(double)valid_fr);
 F_Off_RMS_2=sqrt(F_Off_RMS_2/(double)valid_fr);
 F_Off_RMS_3=sqrt(F_Off_RMS_3/(double)valid_fr);
 F_Off_RMS_4=sqrt(F_Off_RMS_4/(double)valid_fr);
 Amp_RMS_Err=sqrt(Amp_RMS_Err/(double)valid_fr);
 NVar_RMS_Err=sqrt(NVar_RMS_Err/(double)valid_fr);
 NVar_RMS_Err=NVar_RMS_Err/sqrt(2.0*Variance);           /* Normalized value. */
 return(0);
}
/******************************************************************************/
/*                        Print various parameters.
*******************************************************************************/
int Print_Parameters()
{
 printf("\t 1st attempt RMS freq. est. error is: %16.12lf.\n",F_Off_RMS);
 printf("\t 2nd attempt RMS freq. est. error is: %16.12lf.\n",F_Off_RMS_2);
 printf("\t 3rd attempt RMS freq. est. error is: %16.12lf.\n",F_Off_RMS_3);
 printf("\t 4th attempt RMS freq. est. error is: %16.12lf.\n",F_Off_RMS_4);
 printf("\n");
 printf("\t 1st attempt max. freq. est. error: %16.12lf.\n",Max_F_Off_Err);
 printf("\t 2nd attempt max. freq. est. error: %16.12lf.\n",Max_F_Off_Err_2);
 printf("\t 3rd attempt max. freq. est. error: %16.12lf.\n",Max_F_Off_Err_3);
 printf("\t 4th attempt max. freq. est. error: %16.12lf.\n",Max_F_Off_Err_4);
 printf("\n");
 printf("\t No. of bit errors of uncoded QPSK is: %d.\n",Ber);
 printf("\t No. of bit errors of turbo coded QPSK is: %d.\n",T_Ber);
 printf("\t No. of valid bits is: %d.\n\n",Valid_Bit);
 printf("\t No. of frame erasures is: %d.\n",Erasure);
 printf("\t No. of tx. frames is: %d.\n\n",MAX_FRAMES);
 printf("\t 1st attempt Var. of tim. error: %16.12lf * T.\n",Tim_Var);
 printf("\t 2nd attempt Var. of tim. error: %16.12lf * T.\n",Tim_Var_2);
 printf("\t 3rd attempt Var. of tim. error: %16.12lf * T.\n",Tim_Var_3);
 printf("\n");
 printf("\t RMS amp. est. error: %16.12lf.\n",Amp_RMS_Err);
 printf("\t Norm. RMS noise var. est. error: %16.12lf.\n",NVar_RMS_Err);
 return(0);
}
/******************************************************************************/
