/******************************************************************************/
/*   Copyright (C) 2006 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "deal7type.h"
#include "deal7ext.h"
/******************************************************************************/
/*                   Get the symbol to be transmitted.
*******************************************************************************/
int Get_Frame()
{
 Get_Data_Parity1();
 Get_Parity2();
// if(Frame_Cnt == 16188)
//  Print_Frame();
 return(0);
}
/******************************************************************************/
/*                          Get data and parity 1.
*******************************************************************************/
int Get_Data_Parity1()
{
 int cnt,bit,enc_bit;
 long int random(void);
 Enc_State=ZERO;                                /* Encoder 1 state at time 0. */
 for(cnt=ZERO;cnt<DATA_SIZE;cnt++)
 {
  bit=Bits[cnt]=random()&1;
  enc_bit=Trel_Op[Enc_State][bit];
  if((cnt%TWO) == ZERO)                    /* Parity 1 at even time instants. */
   Sym[cnt+PRE_AMB_SIZE]=TWO*enc_bit+bit;                 /* Data bit in LSB. */
  Enc_State=Trel_NS[Enc_State][bit];                   /* Get the next state. */
 }
 return(0);
}
/******************************************************************************/
/*                   Get the interleaved and encoded bits.
*******************************************************************************/
int Get_Parity2()
{
 int cnt,bit,enc_bit,iv_inx;
 Enc_State=ZERO;                                /* Encoder 2 state at time 0. */
 for(cnt=ZERO;cnt<DATA_SIZE;cnt++)
 {
  iv_inx=De_Iv_Map[cnt];
  bit=Bits[iv_inx];
  enc_bit=Trel_Op[Enc_State][bit];
  if((cnt%TWO) == ONE)                      /* Parity 2 at odd time instants. */
   Sym[cnt+PRE_AMB_SIZE]=TWO*enc_bit+Bits[cnt];
  Enc_State=Trel_NS[Enc_State][bit];                   /* Get the next state. */
 }
 return(0);
}
/******************************************************************************/
/*                             Print the frame.
*******************************************************************************/
Print_Frame()
{
 int cnt,start_inx,inx;
 start_inx=1270;
 for(cnt=start_inx;cnt<start_inx+PRE_AMB_SIZE;cnt++)
 {
  inx=cnt-start_inx;
  printf("Fr:%d ti:%d sym:%d preamb:%d\n",Frame_Cnt,cnt,Sym[cnt],Sym[inx]);
 }
 fflush(stdout);
 return(0);
}
/******************************************************************************/
